package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.shop.service.ShopGoodsService;
import com.gxwebsoft.shop.entity.ShopGoods;
import com.gxwebsoft.shop.param.ShopGoodsParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 商品记录表控制器
 *
 * @author 科技小王子
 * @since 2024-09-10 21:05:07
 */
@Api(tags = "商品记录表管理")
@RestController
@RequestMapping("/api/shop/shop-goods")
public class ShopGoodsController extends BaseController {
    @Resource
    private ShopGoodsService shopGoodsService;

    @ApiOperation("分页查询商品记录表")
    @GetMapping("/page")
    public ApiResult<PageResult<ShopGoods>> page(ShopGoodsParam param) {
        // 使用关联查询
        return success(shopGoodsService.pageRel(param));
    }

    @ApiOperation("查询全部商品记录表")
    @GetMapping()
    public ApiResult<List<ShopGoods>> list(ShopGoodsParam param) {
        // 使用关联查询
        return success(shopGoodsService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:shopGoods:list')")
    @OperationLog
    @ApiOperation("根据id查询商品记录表")
    @GetMapping("/{id}")
    public ApiResult<ShopGoods> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(shopGoodsService.getByIdRel(id));
    }

    @ApiOperation("添加商品记录表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody ShopGoods shopGoods) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          shopGoods.setUserId(loginUser.getUserId());
        }
        if (shopGoodsService.save(shopGoods)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改商品记录表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody ShopGoods shopGoods) {
        if (shopGoodsService.updateById(shopGoods)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除商品记录表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (shopGoodsService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加商品记录表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<ShopGoods> list) {
        if (shopGoodsService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改商品记录表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<ShopGoods> batchParam) {
        if (batchParam.update(shopGoodsService, "goods_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除商品记录表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (shopGoodsService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
